<?php

/**
 * update/create externaluser module
 *
 * This module updates/creates external users that are linked to g2 users
 *
 * @version $Revision: 0.8 $ $Date: 2006/01/12 06:29:28 $
 * @package updateexternaluser
 * @author Jozsef R.Nagy <jozsef.rnagy@site.hu>
 *
 */
class UpdateExternalUserModule extends GalleryModule {

    function UpdateExternalUserModule() {
	global $gallery;

	$this->setId('updateexternaluser');
	$this->setName($gallery->i18n('Update External User'));
	$this->setDescription($gallery->i18n('Update external users'));
	$this->setVersion('1.0.0'); 
	$this->setGroup('data', $this->translate('Extra Data'));
	$this->setCallbacks('registerEventListeners');
	$this->setRequiredCoreApi(array(6, 0));
	$this->setRequiredModuleApi(array(2, 0));
    }

    /**
     * @see GalleryModule::registerEventListeners()
     */
    function registerEventListeners() {
	GalleryCoreApi::registerEventListener('GalleryEntity::save',
					      new UpdateExternalUserModule());
    }

   /**
     * @see GalleryModule::autoConfigure()
     */
    function autoConfigure() {
	return array(GalleryStatus::success(), true);
    }

    /**
     * @see GalleryModule::needsConfiguration
     */
    function needsConfiguration() {
	return array(GalleryStatus::success(), false);
    }
    
    /**
     * Update external users that are linked to G2 users
     * @see GalleryEventListener::handleEvent
     */
    function handleEvent($event) {
    global $gallery; 
    
    $entity = $event->getEntity();
    
	if (GalleryUtilities::isA($entity, 'GalleryUser')) {
	    /* It's a GalleryUser entity save event */
	    if (!$entity->testPersistentFlag(STORAGE_FLAG_NEWLY_CREATED)) {
		/* Only handle user data updates here, not the user creation */

		/* Get the corresponding external id for this user */
		list ($ret, $externalId) = $this->getExternalIdByEntityId($entity->getId(),
									  'GalleryUser');
		if ($ret->isError()) {
		    return array($ret->wrap(__FILE__, __LINE__), null);
		}

		/* TODO: Include here the external application -=slave- files and boot it */
		/* Current version works with PHPBB 2.0.18 */
		//Specify where phpbb exists from here
		$phpbb_root_path = '../phpbb/';

		//Specify the file where config of dbAccess exists in.
		/* an example configfile consists these (it can be found in phpbb/config.php for phpbb)
		$dbhost = 'localhost';
		$dbname = 'phpbb';
		$dbuser = 'phpbbDbUser';
		$dbpasswd = 'phpbbDbPassword';
		*/
		include($phpbb_root_path . 'config.php');

		/* connect to the db */
		$dbphpbb = mysql_connect($dbhost,$dbuser,$dbpasswd);
		mysql_select_db($dbname, $dbphpbb);

		//populate var assoc with phpbbvalues
		$sqlphpbbq = "SELECT username, user_password, user_email FROM phpbb_users WHERE user_id=".$externalId;
		$resultphpbbq = mysql_query($sqlphpbbq,$dbphpbb);;
		$valuesphpbb=mysql_fetch_array($resultphpbbq, MYSQL_NUM);

		//populate vars with g2values
		//$valuesg2[0]=$entity->getUserName();
		$valuesg2[1]=$entity->gethashedPassword();
		$valuesg2[2]=str_replace("\'", "''", $entity->getEmail());

		//No username sync for now
		//$valuesg2[0] != $valuesphpbb[0])
		if ( ($valuesg2[1] != $valuesphpbb[1]) || ($valuesg2[2] != $valuesphpbb[2])){
		/* if phpbb and g2 has different data update it else dont do anything */

		/* TODO: language update, convert hu_HU=>hungarian, etc
		/* user_lang = '" . str_replace("\'", "''", $user_lang) . "' */
		
		/* Do the update itself */
		$sqlphpbb = "UPDATE phpbb_users SET user_password= '".$valuesg2[1]."',user_email = '" .$valuesg2[2]."' WHERE user_id ='".$externalId ."'";

		$resultphpbb = mysql_query($sqlphpbb,$dbphpbb);
		}

	    }
	
	/* let's handle when it's a new user creation IN G2!: */
	else {

	//Specify where phpbb exists from here
	$phpbb_root_path = '../phpbb/';

	//Specify the file where config of dbAccess exists in.
	/* an example configfile consists these (it can be found in phpbb/config.php for phpbb)
	$dbhost = 'localhost';
	$dbname = 'phpbb';
	$dbuser = 'phpbbDbUser';
	$dbpasswd = 'phpbbDbPassword';
	*/
	include($phpbb_root_path . 'config.php');

	/* connect to the db */
	$dbphpbb = mysql_connect($dbhost,$dbuser,$dbpasswd);
	mysql_select_db($dbname, $dbphpbb);

	/* Populate var assoc with phpbbvalues 
	/* UTF8=>iso8859 conversion for the phpbbdatabase -it's optional for users with english boards */

	$nonUtfUsernev=GalleryCoreApi::convertFromUtf8($entity->getUserName(), 'ISO-8859-2');

	$sqlphpbbq = "SELECT username, user_email FROM phpbb_users WHERE username='".$nonUtfUsernev."'";
	$resultphpbbq = mysql_query($sqlphpbbq,$dbphpbb);;
	$valuesphpbb=mysql_fetch_array($resultphpbbq, MYSQL_NUM);

	//populate vars with g2values
	$valuesg2[0]=$entity->getUserName();
	//$valuesg2[2]=str_replace("\'", "''", $entity->getEmail());
	if ($nonUtfUsernev != $valuesphpbb[0]){ //this username not exists in slave (phpbb) yet

			//TODO: replace message_dies
			$sqlphpbb = "SELECT MAX(user_id) AS total FROM phpbb_users";
			if ( !($resultphpbb = mysql_query($sqlphpbb,$dbphpbb)) )
			{
				message_die(GENERAL_ERROR, 'Could not obtain next user_id information', '', __LINE__, __FILE__, $sqlphpbb);
			}

			if ( !($row = mysql_fetch_row($resultphpbb)  ))
			{
				message_die(GENERAL_ERROR, 'Could not obtain next user_id information', '', __LINE__, __FILE__, $sqlphpbb);
			}
			$user_id = $row[0] + 1;

	//we have everything here to create the externalUserIdmap in g2
	$ret = $this->addExternalIdMapEntry($user_id, $entity->getId(), 'GalleryUser');
	if ($ret->isError()) {
	    return array($ret->wrap(__FILE__, __LINE__), null);
	}

	//populate vars with g2values
	$valuesg2[0]=$entity->getUserName();
	$valuesg2[1]=$entity->gethashedPassword();
	$valuesg2[2]=$entity->getEmail();
	$valuesg2[3]=$entity->getId();

	//TODO: user_lang!
	//'" . str_replace("\'", "''", $user_lang) . "'
	//TODO: dateformat based on language
	//user_dateformat,
	//'" . str_replace("\'", "''", $user_dateformat) . "'

			$sqlphpbb = "INSERT INTO phpbb_users (user_id, username, user_regdate, user_password, user_email,  user_level, user_allow_pm, user_timezone, user_active, user_actkey)
				VALUES ($user_id, '" . str_replace("\'", "''", $valuesg2[0]) . "', " . time() . ", '" . str_replace("\'", "''", $valuesg2[1]) . "', '" . str_replace("\'", "''", $valuesg2[2]) . "', 0, 1, 1.00,";
			//don't hassle with activation now
				$sqlphpbb .= "1, '')";

			if ( !($resultphpbb = mysql_query($sqlphpbb)) )
			{
				message_die(GENERAL_ERROR, 'Could not insert data into users table', '', __LINE__, __FILE__, $sqlphpbb);
			}

			$sqlphpbbgr = "SELECT MAX(group_id) AS total FROM phpbb_groups";
			if ( !($resultphpbbgr = mysql_query($sqlphpbbgr,$dbphpbb)) )
			{
				message_die(GENERAL_ERROR, 'Could not obtain next user_id information', '', __LINE__, __FILE__, $sqlphpbbgr);
			}

			if ( !($row = mysql_fetch_row($resultphpbbgr)  ))
			{
				message_die(GENERAL_ERROR, 'Could not obtain next user_id information', '', __LINE__, __FILE__, $sqlphpbbgr);
			}
			$group_id = $row[0] + 1;

			//need to insert into groups too
			$sqlphpbb = "INSERT INTO phpbb_groups (group_name, group_description, group_single_user, group_moderator, group_user_id, group_user_list)
				VALUES ('', 'Personal User', 1, 0, ".$user_id.", ',5,$group_id,')";

			if ( !($resultphpbb = mysql_query($sqlphpbb)) )
			{
				message_die(GENERAL_ERROR, 'Could not insert data into groups table', '', __LINE__, __FILE__, $sqlphpbb);
			}

			$group_id=mysql_insert_id();

			$sqlphpbb = "INSERT INTO phpbb_user_group (user_id, group_id, user_pending)
				VALUES ($user_id, $group_id, 0)";

			if( !($result = mysql_query($sqlphpbb)) )
			{
				message_die(GENERAL_ERROR, 'Could not insert data into user_group table', '', __LINE__, __FILE__, $sqlphpbb);
			}
		
		}//newly created end
	    } 
    }	
	return array(GalleryStatus::success(), null);
    }
    
    /**
     * Map G2 entity id to external id
     *
     * @param string entityId
     * @param string entity type
     * @return object GalleryStatus a status code
     */
    function getExternalIdByEntityId($entityId, $entityType) {
	global $gallery;

	$query = 'SELECT [ExternalIdMap::externalId] FROM [ExternalIdMap] ' .
		 'WHERE [ExternalIdMap::entityId] = ? AND [ExternalIdMap::entityType] = ?';
	list ($ret, $results) = $gallery->search($query, array($entityId, $entityType));
	if ($ret->isError()) {
	    return array($ret->wrap(__FILE__, __LINE__), null);
	}
	if (!($result = $results->nextResult())) {
	    return array(GalleryStatus::error(ERROR_MISSING_OBJECT, __FILE__, __LINE__,
					      "$entityId $entityType"), null);
	}

	return array(GalleryStatus::success(), $result[0]);
    }

    /**
     * Add an externalId<->entityId map entry for existing G2/emApp users/groups
     * example: GalleryEmbed::addExternalIdMapEntry($uid, $g2user->getId(), 'GalleryUser');
     *
     * @param integer/string the user/group id in the embedded application
     * @param integer the entityId of the user/group in G2
     * @param string either 'GalleryUser' for a user mapping, 'GalleryGroup' for a group mapping
     * @return object GalleryStatus
     * @static
     */
    function addExternalIdMapEntry($externalId, $entityId, $entityType) {
	GalleryCoreApi::relativeRequireOnce('modules/core/classes/ExternalIdMap.class');
	$ret = ExternalIdMap::addMapEntry(array('externalId' => $externalId,
						'entityType' => $entityType,
						'entityId' => $entityId));
	if ($ret->isError()) {
	    return $ret->wrap(__FILE__, __LINE__);
	}
	return GalleryStatus::success();
    }

}
?>